* migstat07_spss.zip:   migstat07.sps .

* IBM SPSS Statistics 20, Release 20.0.0.1 .

set length none.
set width 130.
set header off.

* Arbeitsverzeichnis in '<...>' eintragen; z. B. c:\temp */ .
CD '<Arbeitsverzeichnis>'.


* ============================================================================.
*                                                                             .
* SPSS-PROGRAMM ZUR TYPISIERUNG DES MIGRATIONSSTATUS IM MIKROZENSUS 2007      .
*                                                                             .
* Programmautor/en:                                                           .
* SAS-Originalprogramm: Gunter Brueckner (Statistisches Bundesamt;            .
*             Referat F 204 Migration und integration, Wohnen)                .
* Anpassungen an Scientific Use File Mikrozensus 2007: Delia Jaeger,          .
*             Bernhard Schimpl-Neimanns (GESIS, GML)                          .
* Programmzweck:                                                              .
*   Dieses Programm dient der Replikation des Migrationsstatus, Variable MIG, .
*   und der Staatsangehoerigkeit zum Migrationsstatus (MIGS) im Scientific    .
*   Use File (SUF) des Mikrozensus 2007.                                      .
*   Die Programme basieren auf den SAS-Programmen zum Original-Mikrozensus    .
*   des Statistischen Bundesamtes und wurden an Recodierungen des SUF         .
*   angepasst.                                                                .
*   Bei der Replikation der Variablen Staatsangehoerigkeit zum Migrations-    .
*   status (MIGS) ist zu beachten, dass aus Gruenden des Datenschutzes        .
*   Angaben zur zweiten Staatsangehoerigkeit (EF370) nur rudimentaer          .
*   vorhanden sind. Des Weiteren sind die zur Konstruktion von MIGS           .
*   verwendeten Variablen                                                     .
*       EF369 1. Staatsangehoerigkeit                                         .
*   und EF374 Staatsangehoerigkeit: vor Einbuergerung/Zuzug als Spaetauss.    .
*   unterschiedlich codiert. Die Replikation ist deshalb nur eingeschraenkt   .
*   moeglich.                                                                 .
* Weiterfuehrende Programmbeschreibung:                                       .
*   Jaeger, Delia und Bernhard Schimpl-Neimanns: Typisierung des              .
*      Migrationshintergrundes in den Mikrozensus Scientific-Use-Files        .
*      2005-2009. GESIS-Technical Report Nr. 2012/08. Mannheim: GESIS.        .
*      URL: http://www.gesis.org/fileadmin/upload/forschung/publikationen/    .
*         gesis_reihen/gesis_methodenberichte/2012/TechnicalReport_2012-08.pdf.
* Download dieser Datei:                                                      .
*    http://www.gesis.org/missy/studie/klassifikationen/                      .
*    konzepte-und-definitionen/migrationshintergrund/migstat07_spss.zip       .
* Siehe auch Anhang 1: Personen mit Migrationshintergrund - Auf dem Weg zu    .
*   einer definitorischen Abgrenzung - S. 398-407 in:                         .
*   Statistisches Bundesamt, 2011: Bevoelkerung mit Migrationshintergrund.    .
*   Ergebnisse des Mikrozensus 2009. Fachserie 1 Reihe 2.2. Wiesbaden. URL:   .
*   https://www.destatis.de/DE/Publikationen/Thematisch/Bevoelkerung/         .
*   MigrationIntegration/Migrationshintergrund2010220097004.pdf?__blob=       .
*   publicationFile; letzter Zugriff: 24.07.2012                              .
* Programmstruktur:                                                           .
*   0. Datenvorbereitung                                                      .
*   1. Grundtypisierung des Migationshintergrundes                            .
*   2. Identifikation von 3-Generationen-Haushalten                           .
*   3. Endtypisierung der Grosseltern                                         .
*   4. Endtypisierung der Eltern                                              .
*   5. Endtypisierung Befragte                                                .
*   6. Umsetzung von Zeitreihenkompatibilitaet (entfaellt im MZ 2007)         .
*   7. Variablendefinition fuer SUF- und Fachserien-Ergebnisse                .
* Programmstatus:                                                             .
*   Getestet mit IBM SPSS Statistics 20, Release 20.0.0.1, und dem Scientific .
*   Use File Mikrozensus 2007, Version 1 vom 04. 12. 2009. Stand: Juli 2012   .
* ============================================================================.

* Scientific Use File Mikrozensus 2007 mit vollstaendigem Dateinamen inkl. 
*    Verzeichnis einlesen.
* Variablenauswahl fuer Korrektur doppelter IDs und Konstruktion des 
*    Migrationsstatus.
get file = '<mz2007.sav>'
   /keep = EF1   EF3   EF4   EF5   EF8   EF9   EF12  EF30  EF31  
           EF44  EF46  EF47  EF49  EF50  EF51  EF52  EF53  EF54  EF55
           EF366 EF367 EF368 EF369 EF370 EF371 EF372 EF373 EF374 EF663
           EF952 .
missing values all().

* Satznummer Ausgangsfile.
compute ID_ORG = $casenum.
var label ID_ORG 'Satznummer in mz2007.sav vor Recodierungen'.
formats ID_ORG (f6.0).
execute.

* ====================================================================.
* 0. Datenvorbereitung .

* DATENKORREKTUREN: DOPPELTE IDs .
* Quelle: http://www.gesis.org/missy/fileadmin/missy/daten/mikrodaten_tools/
*         Rekodierung_doppelter_Identifikatoren/ID_2007.sps.
* ID_2007.sps mit Kommentaren (*) deaktivieren: .
*     * CD '<Arbeitsverzeichnis>'.
*     * get file='<mz2007.sav>'.
* Kommentar (*) entfernen, aber Variable ID_ORG fuer spaetere .
*   Zusammenfuehrungen der erzeugten Migrationsvariablen mit den.
*   Ausgangsdaten uebernehmen: .
*     delete variables IDX eins d5 phh v663 . 
include file = 'ID_2007.sps'.
execute.

* Originalvariablen als EF4_ORG und EF5_ORG sichern.
rename variables (EF4 = EF4_ORG) (EF5 = EF5_ORG).
execute.

* Korrigierte IDs umbenennen.
rename variables (EF4R = EF4) (EF5R = EF5).


* Datenkorrektur Mutter-Kind-Bezug: EF3=9931 & EF4=6 .
*     
*   EF3   EFf4   EF5   EF52   EF53   EF44   EF46 
* ----------------------------------------------
*  9931     6     1      1      2     44      2  ==> EF52=0 , EF53=99
*  9931     6     2      1      1     14      2 
*  .
rename variables (EF52 = EF52_ORG) (EF53 = EF53_ORG).
compute EF52 = EF52_ORG.
compute EF53 = EF53_ORG.
if (EF3=9931 & EF4=6 & EF5=1) EF52 =  0.
if (EF3=9931 & EF4=6 & EF5=1) EF53 = 99.
var label EF52 'F12 Mutter im Haushalt: fuer Ledige - korrigiert'.
var label EF53 'F12 Nr. der Mutter im Haushalt - korrigiert'.
formats EF52 (f1.0) EF53 (f2.0).
value labels EF52 0 'Entfaellt' 1 'Ja' 8 'Nein'.
value labels EF53 1 'Person 01' 2 'Person 02' 3 'Person 03' 4 'Person 04' 5 'Person 05'
                  6 'Person 06' 7 'Person 07' 8 'Person 08' 9 'Person 09' 
                 99 'Entfaellt'.



* Sortierung mit korrigierten IDs.
sort cases by ef1 ef3 ef4 ef5.

* Variablenauswahl mit korrigierten IDs speichern.
save outfile = 'mz2007r_mig.sav'
   /keep = EF1   EF3   EF4   EF5   EF12  EF30  EF31  
           EF44  EF46  EF47  EF49  EF50  EF51  EF52  EF53  EF54  EF55
           EF366 EF367 EF368 EF369 EF370 EF371 EF372 EF373 EF374 EF663
           EF952 EF8   EF9   ID_ORG EF4_ORG EF5_ORG  EF52_ORG EF53_ORG.


* =======================================================================.

* HARMONISIERUNG DER STAATSANGEHOERIGKEITEN IM SCIENTIFIC USE FILE (SUF) .

* Im SUF sind die Staatsaengehoerigkeiten unterschiedlich codiert bzw. aus 
* Datenschutzgruenden vergroebert. Zur 2. Staatsangeh. (EF370) ist nur bekannt,
* ob diese vorhanden ist. In den Originaldaten sind die einzelnen 
* Staatsangehoerigkeiten ausgewiesen.
* Die Typisierung der Staatsangehoerigkeit zum Migrationsstatus des 
* Statistischen Bundesamtes (MIGS, SA_erw) kann deshalb nur naeherungsweise
* repliziert werden.
* ==> Harmonisierte Recodierung EF369 und EF374 .
* ==> Zuweisung unten "SA2=ef370;" deaktiviert, da EF370 = 1 vorhanden <> 1=Belgien .

rename variables (EF369 = EF369_ORG) (EF374 = EF374_ORG).
execute.

recode EF369_ORG (59=58) (else=copy) into EF369.
var label EF369 '1. Staatsangehoerigkeit - recodiert'.
formats EF369 (f2.0).

recode EF374_ORG (8=4) (1=21) (3=25) (15 17=31) (30=33) (98=55) (else=copy) 
  into EF374.
var label EF374 'Staatsangehoerigkeit: vor Einbuergerung/Zuzug als Spaetaussiedler - recodiert'.
formats EF374 (f2.0).

value label EF369 EF374
   0 'Entfaellt (Deutsche ohne weitere Staatsangehoerigkeit)'
   4 '4/8/27: Daenemark(4); Finnland(8); Schweden(27)'
   9 'Frankreich'
  10 'Griechenland'
  13 'Italien'
  21 '1/18/21: Belgien(1); Luxemburg(18); Niederlande(21)'
  22 'Oesterreich'
  23 'Polen'
  24 'Portugal'
  25 '3/25: Bulgarien(3); Rumaenien(25)'
  31 '7/15/17/19/31/37: Estland(7); Lettland(15); Litauen(17); Malta(19); Slowenien(31); Zypern(37)'
  32 'Spanien'
  33 '30/33: Slowakei(30); Tschechische Republik(33)'
  35 'Ungarn'
  36 '11/36: Irland(11); Vereinigtes Koenigreich(36)'
   2 'Bosnien und Herzegowina'
   5 'Ehemalige Sowjetunion'
   6 'Ehemaliges Jugoslawien'
  14 'Kroatien'
  26 'Russische Foederation'
  28 '12/16/20/28: Island(12); Liechtenstein(16); Norwegen(20); Schweiz(28)'
  34 'Tuerkei'
  38 'Sonstiges Osteuropa'
  39 'Sonstiges Europa'
  56 'Ukraine'
  58 '58/59: Serbien(58); Montenegro(59)'
  40 'Marokko'
  41 'Sonstiges Nordafrika'
  42 'Sonstiges Afrika (ohne Marokko)'
  43 'Vereinigte Staaten von Amerika (USA)'
  45 '44/45: Sonstiges Nordamerika [Kanada](44); Mittelamerika und Karibik(45)'
  46 'Suedamerika'
  47 'Irak'
  48 'Iran'
  49 'Sonstiger Naher und Mittlerer Osten (ohne Iran)'
  57 'Kasachstan'
  50 'Vietnam'
  51 'Afghanistan'
  52 'Sonstiges Sued- und Suedostasien'
  53 'China'
  54 'Sonstiges Ostasien'
  55 '55/98: Uebrige Welt(55); Staatenlos(98)'.

* Europa: .
* - EU-27: 4  9 10 13 21 22 23 24 25 31 32 33 35 36.
* - Sonstiges Europa:  2  5  6 14 26 28 34 38 39 56 58 .
* Afrika:  40 41 42 .
* Amerika: 43 45 46 .
* Asien, Australien und Ozeanien.
* - Naher und Mittlerer Osten: 47 48 49 57.
* - Sued- und Suedostasien: 50 51 52.
* - China, Sonstiges Ostasien: 53 54.
* Uebrige Welt, Staatenlos: 55.
execute.


* ====================================================================.
* 1. Grundtypisierung des Migrationshintergrundes                     .
*    Es werden zunaechst nur die Angaben der Person selbst zur        .
*    Typisierung verwendet. Die erste Typisierung erfolgt nach        .
*    Angaben zur Staatsangehoerigkeit (deutsch / nicht-deutsch) und   .
*    Geburtsland (Ausland / Inland).                                  .
*    Zur Unterscheidung der Gruppe eingebuergerter Zuwanderer (MIG=31).
*    nach einem evtl. Status als Spaetaussiedler wird abschliessend   .
*    geprueft ob der Ehegatte, der Vater oder die Mutter im Haushalt  .
*    einen Spaetaussiedlerstatus besitzt.                             .
*    Trifft dies zu, erfolgt eine Rekodierung (Plausibilisierung)     .
*    von MIG=31 'zugewanderter eingebuergerter Auslaender'            .
*    zu  MIG=22 'Ehegatte oder Kind eines (Spaet-)Aussiedlers         .
*                (mit/ohne Einbuerg)'                                 .

compute Gebj=ef47.
formats Gebj (f4.0).

compute BRDBorn=ef366.
formats BRDBorn (f1.0).
var label BRDBorn 'Geburtsland: BRD (EF366)'.
val label BRDBorn 1 'Ja, hier geboren' 8 'Nein, zugezogen' 9 'ohne Angabe'.

recode BRDBorn (1=0) (8=1) (9=9) (else=9) into Zuzug.
formats Zuzug (f1.0).
var label Zuzug 'Zuzug ex BRDBorn, EF366'.
value label Zuzug 0 'kein Zuzug' 1 'foreign born' 2 'Zuzug nach 6+ Mo im Ausland:= in D geboren' 9 'k.A.'.

compute JZuzug=ef367.
recode JZuzug (9999=9).
value label JZuzug 1949 'Zuzug vor 1950' 9 'o.A. zum Zuzugsjahr (9999)'  0 'kein Zuzugsjahr sinnvoll'.
formats JZuzug (f4.0).

if (BRDBorn=1 & JZuzug>9) Zuzug=2.
if (BRDBorn=8 & JZuzug<10) JZuzug=9.
* SA*: Staatsangehoerigkeit .
* nur deutsche SA .
do if (ef368=1). 
   compute Ausl=0.
   compute SADopp=0.
   compute SA1=0.
   compute SA2=$sysmis.
* deutsche und auslaendische SA .
else if (ef368=2). 
   compute Ausl=0.
   compute SADopp=1.
   compute SA1=0.
   compute SA2=ef369.
 * nur auslaendische SAs .
else.  
   compute Ausl=1.
   compute SA1=ef369.
   if (ef370=0) SADopp=0.
   if (ef370=0) SA2=$sysmis.
   if (ef370<>0) SADopp=1. /* DEAKTIVIERT: SA2=ef370; */
end if.
value label Ausl SADopp 0 'nein' 1 'ja'.
formats Ausl SADopp SA1 (f1.0) SA2 (f2.0).


* ####### Eingebuergerte/Spaetaussiedler und Staatsangehoerigkeit davor ####### .
* "Erwerb der dt. Staatsangehoerigkeit": (EF372 neue Codes ab 2007): .
*  SUF 2007 .
*    1 Deutsche Staatsangehoerigkeit durch Geburt:        SpAuss=9;  Eingeb=0 .
*    2 Deutsche Staatsangehoerigkeit als Spaetaussiedler: SpAuss=1;  Eingeb=1 .
*    3 Deutsche Staatsangehoerigkeit durch Einbuergerung: SpAuss=0;  Eingeb=1 . 


/* Spaetaussiedler ohne Einbuergerung */
do if (ef372=2). 
   compute SpAuss=1.
   compute Eingeb=0.       /* XXX 2007: . vs. 2008: 1 */
   compute JEinb=$sysmis.  /* XXX 2007 <> 2008 XXX */
   recode ef374 (0=sysmis) (else=copy) into SA3.
   recode ef369 (0=sysmis) (else=copy) into SA2.
* Einbuergerung  .
else if (ef372=3).
   compute SpAuss=0.
   compute Eingeb=1.
   recode ef373 (0=9) (else=copy) into JEinb.
   recode ef374 (0=sysmis) (else=copy) into SA3.
   recode ef369 (0=sysmis) (else=copy) into SA2.
* Deutsch durch Geburt .
else.
  compute SpAuss=0.
  compute Eingeb=0.
  compute JEinb=$sysmis.
  compute SA3=0.
  recode ef369 (0=sysmis) (else=copy) into SA2.
end if.
val label SpAuss Eingeb 0 'nein' 1 'ja'.
formats SpAuss Eingeb (f1.0) JEinb (f4.0) SA3 (f2.0).
execute.

* KONTROLLE 1 .
* fre SpAuss Eingeb JEinb sa1 sa2 sa3 .


/* ####### Grundtypisierung des Migrationshintergrundes ####### */
* MIG: Migrationstypus
  1. Stelle: Migrationstyp: 
     1=vertrieben;
     2=als Deutsche/r bzw. Spaetaussiedler zugewandert;
     3=eingebuergert;
     4=Auslaender/in;
  2. Stelle: Generation: 
     1=im Ausland geboren, 
     2=in Deutschland geboren  .
* MIG: 11=Vertriebene vor 1950;
       21=Deutsche Zuwanderer oder (Spaet-)Aussiedler (ohne Einbuergerung);
       22=Ehegatte oder Kind eines (Spaet-)Aussiedlers (mit/ohne Einbuergerung);
       25=(Spaet-)Aussiedler (mit Einbuergerung) $$$ nicht 2007 $$$ ;
       29=(Spaet-)Aussiedler (mit/ohne Einbuergerung) o.A. zum Zuzugsjahr;
       31=zugewanderte/r eingebuergerte/r Auslaender/in;
       32=nicht zugewanderte/r eingebuergerte/r Auslaender/in;
       41=zugewanderte/r Auslaender/in;
       42=nicht zugewanderte/r Auslaender/in;
       77=uneindeutig ob deutsch, vertrieben oder Spaetaussiedler 
       99=fehlende/unvollstaendige Angaben  .

* SA: aktuelle Staatsangehoerigkeit .

* SA_erw: erweiterte aktuelle Staatsangehoerigkeit gewonnen aus SA1 - SA3 nach folgenden Regeln:
          0=deutsch (bei MIG=0, 11);
           =SA1 (bei Mig=41,42);
           =SA3 (bei Mig=21,25,29,31,32 und SA3<>.);
           =SA2 (bei MIG=21,25,29,31,32 und SA3=.und SA2<>.)
           =99 (bei MIG=21,25,29,31,32 und SA2=. und SA3=. oder bei MIG=77,99) .

* A) im Ausland geboren.
* A1) als Ausl zugewandert. 
do if (BRDBorn=8 & Ausl=1).
       compute MIG=41.
       compute SA=SA1.
       compute SA_erw=SA1.
* A2) Spaetaussiedler/in .
else if (BRDBorn=8 & SpAuss=1 & Eingeb=1).
       compute MIG=25.
       compute SA=SA1.
       compute SA_erw=SA3.
       if (sysmis(SA_erw)) SA_erw=SA2.
       if (sysmis(SA_erw)) SA_erw=99.
* Spaetaussiedler ohne Einbuergerung XXX 2007 nicht differenzierbar XXX .
else if (BRDBorn=8 & SpAuss=1 & Eingeb=0).
       compute MIG=21.
       compute SA=SA1.
       compute SA_erw=SA3.
       if (sysmis(SA_erw)) SA_erw=SA2.
       if (sysmis(SA_erw)) SA_erw=99.
* kein Spaetaussiedler ... .
* A3) Eingebuergerte/r .
else if (BRDBorn=8 & SpAuss=0 & Eingeb=1).
       compute MIG=31.
       compute SA=SA1.
       compute SA_erw=SA3.
       if (sysmis(SA_erw)) SA_erw=SA2.
       if (sysmis(SA_erw)) SA_erw=99.
* ... Deutsche/r durch Geburt.
* A4) Vertriebener vor 1950 .
else if (BRDBorn=8 & SpAuss=0 & Eingeb=0 & JZuzug=1949).
       compute MIG=11.
       compute SA=SA1.
       compute SA_erw=SA1.
* A5) Aussiedler-Aequivalent .
else if (BRDBorn=8 & SpAuss=0 & Eingeb=0 & JZuzug>1949).
       compute MIG=21.
       compute SA=SA1.
       compute SA_erw=SA3.
       if (sysmis(SA_erw)) SA_erw=SA2.
       if (sysmis(SA_erw)) SA_erw=99.
* ... Zuzugsjahr missing: Zuzug ohne Angabe zum Jahr d.h. kann Vertriebener
*     oder Spaetaussiedler sein.
* Annahme 1: wenn nach 1949 geboren, als Spaetaussiedler zugewandert.
else if (BRDBorn=8 & SpAuss=0 & Eingeb=0 & JZuzug=9 & Gebj>1949).
       compute MIG=21.
       compute SA=SA1.
       compute SA_erw=SA3.
       if (sysmis(SA_erw)) SA_erw=SA2.
       if (sysmis(SA_erw)) SA_erw=99.
* Annahme 2: Wenn vor 1949 geboren und keine auslaendische SA dann Vertriebener .
else if (BRDBorn=8 & SpAuss=0 & Eingeb=0 & Gebj<=1949 & SADopp=0 & SA1=0).
       compute MIG=11.
       compute SA=SA1.
       compute SA_erw=SA1.
* Annahme 3: sonst Zuzug als Spaetaussiedler ohne Datumsangabe: 29 .
else if (BRDBorn=8 & SpAuss=0 & Eingeb=0 & JZuzug=9 & Gebj<=1949 & SADopp=1 & SA1=0).
       compute MIG=29.
       compute SA=SA1.
       compute SA_erw=SA3.
       if (sysmis(SA_erw)) SA_erw=SA2.
       if (sysmis(SA_erw)) SA_erw=99.
* B) im Inland geboren: .
* B1) als Auslaender in D geboren .
else if (BRDBorn=1 & Ausl=1).
       compute MIG=42.
       compute SA=SA1.
       compute SA_erw=SA1.
* B2) Spaetaussiedler/in, Fehler! .
else if (BRDBorn=1 & SpAuss=1).
       compute MIG=77.
       compute SA=SA1. 
       compute SA_erw=SA3.
       if (sysmis(SA_erw)) SA_erw=SA2.
       if (sysmis(SA_erw)) SA_erw=99.
* B3) Eingebuergerte/r .
else if (BRDBorn=1 & Eingeb=1).
       compute MIG=32.
       compute SA=SA1. 
       compute SA_erw=SA3.
       if (sysmis(SA_erw)) SA_erw=SA2. 
       if (sysmis(SA_erw)) SA_erw=99.
* B4) in Deutschland geborener Deutscher .
else if (BRDBorn=1 & Ausl=0 & SpAuss=0 & Eingeb=0).
       compute MIG=77.
       compute SA=SA1. 
       compute SA_erw=SA2.
       if (sysmis(SA_erw)) SA_erw=SA1.
* keine Auskunft; kommt wohl nicht vor .
else if (BRDBorn=9).
       compute Mig=99.
       compute SA=SA1.
       compute SA_erw=SA3.
       if (sysmis(SA_erw)) SA_erw=SA1.
end if.
execute.

formats mig (f2.0).

* KONTROLLE 2.
* fre mig sa_erw .

* ============= ZWISCHENSPEICHERUNG ===== .
formats BRDBorn Zuzug Ausl SADopp SpAuss Eingeb (f1.0).
formats SA1 SA2 SA3 SA_erw  MIG (f2.0).
formats Gebj  JZuzug JEinb (f4.0). 
var label MIG 'Migrationsstatus'.
recode MIG (sysmis=0).
value label MIG   0 'SYSMIS'
                 11 'Vertriebene vor 1950'
               	 21 'Deutsche Zuwanderer oder (Spaet-)Aussiedler (ohne Einbuergerung)'
               	 22 'Ehegatte oder Kind eines (Spaet-)Aussiedlers (mit/ohne Einbuergerung)'
               	 25 '(Spaet-)Aussiedler (mit Einbuergerung)'
               	 29 '(Spaet-)Aussiedler (mit/ohne Einbuergerung) o.A. zum Zuzugsjahr'
               	 31 'zugewanderte/r eingebuergerte/r Auslaender/in'
               	 32 'nicht zugewanderte/r eingebuergerte/r Auslaender/in'
               	 41 'zugewanderte/r Auslaender/in'
               	 42 'nicht zugewanderte/r Auslaender/in'
               	 77 'uneindeutig ob deutsch, vertrieben oder Spaetaussiedler'
               	 99 'fehlende/unvollstaendige Angaben'.

rename variables (MIG = MIG1).
var label MIG1 'Migrationsstatus Grundtypisierung vor Plausibilisierung Spaetaussiedler (MIG=31)'.
execute.


* ============================================================================.
* Wenn Zuwanderer angibt, eingebuergert zu sein (Mig=31), dann pruefen, ob ggf. 
* Spaetaussiedlerstatus vorliegt: .
* a) Ehegatte ist Spaetaussiedler (MIG[Ehegatte]=21-29) .
* b) Vater ist Spaetaussiedler (MIG[Vater]=21-29) .
* c) Mutter ist Spaetaussiedler (MIG[Mutter]=21-29) .
* ----------------------------------------------------------------------------.

* A) PLAUSIBILISIERUNG - EHEGATTE .
* ~SAS: 02Vorlauf.sas .
*         if EF366 = 8 & EF372 = 2 & Jahrzuzug>1949 then do; output mzjahr.vorlauf1; .
*       03Grundtypisierung*.sas .
*         if jahrzuzug > 10 and abs(jahrzuzug-_jahrzuzug_)<3 then MIG=22;  .
* EF366 Geburtsland: BRD 8=Nein .
* EF372 2=Deutsche Staatsangehoerigkeit als Spaetaussiedler.
* ----------------------------------- .
compute VORL = (EF366=8 & EF372=2 & JZuzug>1949).
var label VORL 'Valide Spaetaussiedler - PERSON'.
formats VORL (f1.0).
execute.

temporary.
select if (ef50=1)  /* Ehegatte im Haushalt */ .
save /outfile='temp_E.sav'
     /keep  = ef1 ef3 ef4 ef5 mig1 VORL JZuzug ef366 ef372 
     /rename (ef5   JZuzug   ef366   ef372   mig1   VORL = 
              ef5_E JZuzug_E ef366_E ef372_E mig1_E VORL_E).
execute.

if (ef50=1) ef5_E = ef51.
var label ef5_E 'Nr. des Ehepartners im Haushalt (ef51)'.
formats ef5_E (f2.0).

* Sortierung fuer Zusammenspielen Ehegatten. 
sort cases by ef1 ef3 ef4 ef5_E.

* Angaben der Ehegatten zusammenspielen. 
match files file=*
           /file='temp_E.sav'
           /by ef1 ef3 ef4 ef5_E.
execute.
* Warnung doppelte IDs kann ignoriert werden .


* Sortierung des Ausgangsfiles wieder herstellen: .
sort cases by  ef1 ef3 ef4 ef5.

compute MIG1a=MIG1.
if (MIG1=31                          /* Wenn Zuwanderer angibt, eingebuergert zu sein (Mig=31) */
    & JZuzug>10 & JZuzug_E>1949      /* und valides Zuzugsjahr */
    & EF50=1                         /* Ehegatte im Haushalt (ergaenzt) */
    & (abs(JZuzug-JZuzug_E)<3) /* Diff +- 3 Jahre zum Zuzugsjahr des Ehegatten */
    & VORL_E=1)                      /* Ehegatte ist valider Spaetaussiedler:= EF366 = 8 & EF372 = 2 & JZuzug>10  */
    MIG1a=22.
formats MIG1a (f2.0).
var label MIG1a 'Migrationsstatus nach Plausib a) Ehegatte'.


* temporary.
* select if (MIG1a<>MIG1). 
* crosstabs MIG1a by MIG1.
* n=126 Rekodierungen MIG1=31 -> MIG1a=22.

* ----------------------------------------------------------------------------.

* B) PLAUSIBILISIERUNG - VATER .
*    EF54 Vater im Haushalt: fuer Ledige: 1=ja 8=nein 0=entf.
*    EF55 Nr. des Vaters im Haushalt .
compute vnr = ef55 * (ef54=1).
formats vnr (f2.0).
var label vnr 'Personennr. des Vaters (ef55)'.

* ==> Sortierung ... vnr.
sort cases by  ef1 ef3 ef4 vnr.

temporary.
select if (vnr>0).
compute ef5=vnr.
aggregate outfile='temp_V1.sav'
     /break ef1 ef3 ef4 ef5
     /V_Kids 'Kinder des Vaters' = n.
execute.

sort cases by  ef1 ef3 ef4 ef5.
* Angaben des Vaters zuspielen. 
match files file=*
           /table='temp_V1.sav'
           /by ef1 ef3 ef4 ef5.
execute.

recode V_Kids (1 thru hi=1) into VATER.
var label VATER 'Vater lediger Kinder im HH'.
formats VATER (f1.0).


temporary.
select if (VATER=1).
save /outfile='temp_V2.sav'
     /keep  = ef1 ef3 ef4 ef5 mig1a VORL JZuzug ef366 ef372 
     /rename (ef5 JZuzug   ef366   ef372   mig1a   VORL = 
              vnr JZuzug_V ef366_V ef372_V mig1a_V VORL_V).
execute.


* Sortierung fuer Zusammenspielen VATER. 
sort cases by ef1 ef3 ef4 vnr.

* Angaben des Vaters zuspielen. 
match files file=*
           /table='temp_V2.sav'
           /by ef1 ef3 ef4 vnr.
execute.

* Sortierung des Ausgangsfiles wieder herstellen: .
sort cases by  ef1 ef3 ef4 ef5 .

compute MIG1b=MIG1a.
execute.
if (MIG1a=31                         /* Wenn Zuwanderer angibt, eingebuergert zu sein (Mig=31) */
    & JZuzug>10 & JZuzug_V>1949      /* und valides Zuzugsjahr */
    & EF54=1                         /* Vater im Haushalt (ergaenzt) */
    & (abs(JZuzug-JZuzug_V)<3)       /* Diff +- 3 Jahre zum Zuzugsjahr des Vaters */
    & VORL_V=1)                      /* Vater ist valider Spaetaussiedler:= EF366 = 8 & EF372 = 2 & JZuzug>1949  */
    MIG1b=22.
formats MIG1b (f2.0).
var label MIG1b 'Migrationsstatus nach Plausib a) Eheg. + b) Vater'.


* temporary.
* select if (MIG1b<>MIG1a). 
* crosstabs MIG1b by MIG1a.
* n=29 Rekodierungen MIG1a=31 -> MIG1b=22.


* ----------------------------------------------------------------------------.

* C) PLAUSIBILISIERUNG - MUTTER .
*    EF52 Mutter im Haushalt: fuer Ledige: 1=ja 8=nein 0=entf.
*    EF53 Nr. der Mutter im Haushalt .
compute mnr = ef53 * (ef52=1).
formats mnr (f2.0).
var label mnr 'Personennr. der Mutter (ef53)'.

* ==> Sortierung ... mnr.
sort cases by  ef1 ef3 ef4 mnr.

temporary.
select if (mnr>0).
compute ef5=mnr.
aggregate outfile='temp_M1.sav'
     /break ef1 ef3 ef4 ef5
     /M_Kids 'Kinder der Mutter' = n.
execute.

sort cases by  ef1 ef3 ef4 ef5.
* Angaben der Mutter zuspielen. 
match files file=*
           /table='temp_M1.sav'
           /by ef1 ef3 ef4 ef5.
execute.

recode M_Kids (1 thru hi=1) into MUTTER.
var label MUTTER 'Mutter lediger Kinder im HH'.
formats MUTTER (f1.0).


temporary.
select if (MUTTER=1).
save /outfile='temp_M2.sav'
     /keep  = ef1 ef3 ef4 ef5 mig1b VORL JZuzug ef366 ef372 
     /rename (ef5 JZuzug   ef366   ef372   mig1b   VORL = 
              mnr JZuzug_M ef366_M ef372_M mig1b_M VORL_M).
execute.


* Sortierung fuer Zusammenspielen MUTTER. 
sort cases by ef1 ef3 ef4 mnr.

* Angaben der Mutter zuspielen. 
match files file=*
           /table='temp_M2.sav'
           /by ef1 ef3 ef4 mnr.
execute.

* Sortierung des Ausgangsfiles wieder herstellen: .
sort cases by  ef1 ef3 ef4 ef5 .

compute MIG1c=MIG1b.
execute.
if (MIG1b=31                         /* Wenn Zuwanderer angibt, eingebuergert zu sein (Mig=31) */
    & JZuzug>10 & JZuzug_M>1949      /* und valides Zuzugsjahr */
    & EF52=1                         /* Mutter im Haushalt (ergaenzt) */
    & (abs(JZuzug-JZuzug_M)<3)       /* Diff +- 3 Jahre zum Zuzugsjahr der Mutter */
    & VORL_M=1)                      /* Mutter ist valider Spaetaussiedler:= EF366 = 8 & EF372 = 2 & JZuzug>1949  */
    MIG1c=22.
formats MIG1c (f2.0).
var label MIG1c 'Migrationsstatus nach Plausib a) Eheg. + b) Vater + c) Mutter'.


* temporary.
* select if (MIG1c<>MIG1b). 
* crosstabs MIG1c by MIG1b.
* n=8 Rekodierungen MIG1b=31 -> MIG1c=22 <=> SAS !.

* =====================================================================.

compute MIG2 = MIG1c.
formats MIG2 (f2.0).
var label MIG2   'Migrationsstatus nach Plausibilisierungen (MIG=31, a-c)'.


* Speichern Grundtypisierung + Plausibilisierungen .
sort cases by  ef1 ef3 ef4 ef5.
SAVE /OUTFILE='migstat_1.sav'.


* KONTROLLE 3.
* fre mig2 sa_erw.


* ====================================================================.
* 2. Identifikation von 3-Generationen-Haushalten                     .
*    Fuer die nachfolgende Typisierung des Migrationshintergrundes    .
*    von Eltern unter Verwendung von Angaben der Grosseltern werden   .
*    in diesem Schritt 3-Generationen-Haushalte identifiziert und     .
*    Identifikatoren fuer Grossmuetter- und -vaeter gebildet.         .
* ====================================================================.

get file = 'migstat_1.sav'. 

sort cases by  ef1 ef3 ef4 ef5.


* Eltern (Mutter oder Vater) mit Angaben zur (Gross-)Mutter: Personennummer der Grossmutter .
compute gmnr = ( (MUTTER=1 | VATER=1) & ef52=1) * ef53.
* Eltern (Mutter oder Vater) mit Angaben zum (Gross-)Vater:  Personennummer des Grossvaters .
compute gvnr = ( (MUTTER=1 | VATER=1) & ef54=1) * ef55. 

temporary.
* Eltern - Pers.Nr. der Grosseltern .
select if (MUTTER=1 | VATER=1).
aggregate outfile = 'temp_GE.sav'
         /presorted
         /break ef1 ef3 ef4 
         /min_gmnr = min(gmnr)
         /max_gmnr = max(gmnr)
         /min_gvnr = min(gvnr)
         /max_gvnr = max(gvnr).
execute.

* Personennr. der (Grosseltern zuspielen. 
match files file=*
           /table='temp_GE.sav'
           /by ef1 ef3 ef4  .
formats gmnr gvnr min_gmnr max_gmnr min_gvnr max_gvnr (f2.0).
execute.

* Ausgangssortierung fuer Tests.
sort cases by  ef1 ef3 ef4 ef5 .


temporary.
* Kontrolle: mehr als 1 Grossmutter(nummer) im HH? .
*            Voraussetzung fuer "max" gmnr gvnr.
select if (max_gmnr<>min_gmnr & min_gmnr>0).
crosstabs max_gmnr by min_gmnr.

temporary.
* Kontrolle: mehr als 1 Grossvater(nummer) im HH? .
select if (max_gvnr<>min_gvnr & min_gvnr>0).
crosstabs max_gvnr by min_gvnr.

* temporary.
* ggf. Dateninspektion.
* select if ( (max_gmnr<>min_gmnr & min_gmnr>0) 
            | (max_gvnr<>min_gvnr & min_gvnr>0) ).
* list variable ef3 ef4 ef5 ef44 ef46 ef52 ef53 mutter gmnr max_gmnr ef54 ef55 gvnr max_gvnr .
* Grossvater-/mutter .


compute GMutter = (max_gmnr=ef5 & max_gmnr>0).
compute GVater  = (max_gvnr=ef5 & max_gvnr>0).
var label GMutter 'Grossmutter mit Kindern, Enkeln im HH'.
var label GVater  'Grossvater mit Kindern, Enkeln im HH'.
* val label GMutter GVater 1 'ja'.
formats GMutter GVater (f1.0).
execute.


* ====================================================================.
* 3. Endtypisierung der Grosseltern .
*    Im MZ 2007 nicht relevant, da keine Angaben zu den nicht im HH lebenden .
*    Eltern vorhanden, deshalb kann die Grundtypisierung verwendet werden.


* ====================================================================.
* 4. Endtypisierung der Eltern                                        .
*      Fuer jede Kombination von eigenem, vaeterlichen und            .
*      muetterlichen vorlaeufigen Migrationsstatus wird der           .
*      resultierende endgueltige Migrationsstatus zugewiesen. Diese   .
*      Konversions-Prozedur wird nur fuer im Inland Geborene angewandt.
*      Abschliessend wird die Variable erweiterte Staatsangehoerigkeit.
*      (SA_erw) ggf. durch Informationen zum Vater bzw. zur Mutter    .
*      ergaenzt.                                                      .

sort cases by  ef1 ef3 ef4 ef5.

temporary.
select if (GVater=1).
save outfile = 'temp_GV.sav'
         /keep ef3 ef4 ef5 MIG2 SA1  SA2    SA3    SA    SA_erw  
         /rename (ef5  MIG2   SA1    SA2    SA3    SA    SA_erw = 
                  gvnr MIG_GV SA1_GV SA2_GV SA3_GV SA_GV SAerw_GV).
execute.

sort cases by ef1 ef3 ef4 gvnr.

* Angaben der (Gross-) Vaeter zuspielen. 
match files file=*
           /table='temp_GV.sav'
           /by ef3 ef4 gvnr.
execute.
sort cases by  ef1 ef3 ef4 ef5.

* Angaben Status Grossvater nur falls der Grossvater der Vater ist, sonst SYSMIS.
do if (gvnr<>ef55).
 recode MIG_GV SA1_GV SA2_GV SA3_GV SA_GV SAerw_GV (else=sysmis).
end if.
formats MIG_GV SA1_GV SA2_GV SA3_GV SA_GV SAerw_GV (f2.0).
execute.

temporary.
select if (GMutter=1).
save outfile = 'temp_GM.sav'
         /keep ef3 ef4 ef5 MIG2 SA1  SA2    SA3    SA    SA_erw  
         /rename (ef5  MIG2   SA1    SA2    SA3    SA    SA_erw = 
                  gmnr MIG_GM SA1_GM SA2_GM SA3_GM SA_GM SAerw_GM).
execute.

sort cases by ef1 ef3 ef4 gmnr.

* Angaben der (Gross-) Muetter zuspielen. 
match files file=*
           /table='temp_GM.sav'
           /by ef3 ef4 gmnr.
execute.
sort cases by  ef1 ef3 ef4 ef5.

* Angaben Status Grossmutter nur falls die Grossmutter die Mutter ist, sonst SYSMIS.
do if (gmnr<>ef53).
 recode MIG_GM SA1_GM SA2_GM SA3_GM SA_GM SAerw_GM (else=sysmis).
end if.
formats MIG_GM SA1_GM SA2_GM SA3_GM SA_GM SAerw_GM (f2.0).
execute.


* -------------------------------------------------------------------------.
* nur im Inland Geborene werden der Konversions-Prozedur unterworfen .
if not any (MIG2, 11, 21, 22, 23, 25, 29, 31, 41) KonvProc=1.

* EGRE: Eltern - Grosseltern .
if ( (Mutter=1 & gmnr=ef53) |   /* Muetter mit Grossmuettern im HH */
     (Vater =1 & gvnr=ef55) )   /* Vaeter  mit Grossvaetern im HH */
   EGRE = 1.   
formats Konvproc EGRE (f1.0).
execute.

* Vorbereitung MATCH Konversionstabelle.
* 'Converse' enthaelt die Abbildungsvorschriften zur Ermittlung des .
* Migrationsstatus aus den Werten MIG, MIGV und MIGM.
* Fuer jede Kombination von eigenem, vaeterlichen und muetterlichen .
* vorlaeufigen Migrationsstatus wird der resultierende endgueltige .
* Migrationsstatus zurueckgegeben. Die Variable Kennung enthaelt den .
* Fallidentifikator, der die Abbildungsvorschrift eindeutig identifiziert .

do if (EGRE=1 & KonvProc=1).  /* ELTERN MIT GROSSELTERN, im Inland geborene */   
    recode MIG2   (else=copy) into mig_k.                /* MIG-Status Person vor Konversion, hier: Eltern */
    recode MIG_GV (sysmis=99) (else=copy) into migV_k.   /* MIG-Status Grossvater */
    recode MIG_GM (sysmis=99) (else=copy) into migM_k.   /* MIG-Status Grossmutter */
end if.
formats mig_k migV_k migM_k (f2.0).
execute.

sort cases by mig_k migV_k migM_k KonvProc.
match files file = *
            table = 'conversion.sav' 
     /by mig_k migV_k migM_k KonvProc.

* Neu bilden, da ggf. durch Match ueberschrieben.
if not any (MIG2, 11, 21, 22, 23, 25, 29, 31, 41) KonvProc=1.


* Ausgangssortierung.
sort cases by  ef1 ef3 ef4 ef5.

* MIGSTATUS nach Konversion zuweisen.
if not(sysmis(migneu)) MIG3 = migneu.
if (sysmis(migneu))    MIG3 = MIG2.
formats MIG3 (f2.0).
var label MIG3   'Migrationsstatus nach Endtypisierung Eltern'.
execute.

* Veraenderungen MIG nach Endtypisierung Eltern.
* crosstabs MIG3 by MIG2.


* SA_erw durch aussagekraeftigen Vater- oder Muttereintrag ergaenzen, sofern 
*        noetig und moeglich .
do if (KonvProc=1 & EGRE=1).
   if ( (SA_erw=0 | SA_erw=99) & (SAerw_GV>0 & SAerw_GV<99) ) SA_erw=SAerw_GV.
   if ( (SA_erw=0 | SA_erw=99) & (SAerw_GM>0 & SAerw_GM<99) ) SA_erw=SAerw_GM.
end if.
execute.


* Ausgangssortierung .
sort cases by  ef1 ef3 ef4 ef5 .

* Zwischenspeicherung Gesamtfile Grundtypisierung + Endtypisierung Eltern.
save /outfile = 'migstat_2.sav'. 

* KONTROLLE 4.
* fre mig3 sa_erw.


* ====================================================================.
* 5. Endtypisierung Befragte                                          .
*       Analog zur Endtypisierung der Eltern wird der endgueltige     .
*       Migrationsstatus unter Beruecksichtigung der Kombinationen    .
*       von eigenem, vaeterlichen und muetterlichen vorlaeufigen      .
*       Migrationsstatus zugewiesen, wobei auch hier die Zuweisungen  .
*       nur fuer die im Inland Geborenen zur Anwendung kommen, und    .
*       die erweiterte Staatsangehoerigkeit (SA_erw) ggf. durch       .
*       Angaben des Vaters bzw. der Mutter ergaenzt wird.             .
*       Die Variable SA_erw ist Basis der Staatsangehoerigkeit zum    .
*       Migrationsstatus (MIGS).                                      .

sort cases by ef1 ef3 ef4 ef5.

* Migrationsrelevante Eintraege fuer Vaeter:  MIG  SA1 SA2 SA3 SA SA_erw JZuzug.
temporary.
select if (Vater=1).
save outfile = 'temp_V.sav'
         /keep ef3 ef4 ef5 MIG3  SA1   SA2    SA3    SA    SA_erw   JZuzug
         /rename (ef5      MIG3  SA1   SA2    SA3    SA    SA_erw   JZuzug  = 
                  vnr      MIG_V SA1_V SA2_V  SA3_V  SA_V  SA_erw_V JZuzug_V).
execute.

sort cases by ef1 ef3 ef4 vnr.

* Angaben der Vaeter zuspielen. 
match files file=*
           /table='temp_V.sav'
           /by ef3 ef4 vnr.
execute.
sort cases by  ef1 ef3 ef4 ef5.

* ---------------------------------------------------------------- .
* Migrationsrelevante Eintraege fuer Muetter: MIG SA1 SA2 SA3 SA SA_erw JZuzug.
temporary.
select if (Mutter=1).
save outfile = 'temp_M.sav'
         /keep ef3 ef4 ef5 MIG3  SA1   SA2    SA3    SA    SA_erw   JZuzug
         /rename (ef5      MIG3  SA1   SA2    SA3    SA    SA_erw   JZuzug = 
                  mnr      MIG_M SA1_M SA2_M  SA3_M  SA_M  SA_erw_M JZuzug_M).
execute.
sort cases by ef1 ef3 ef4 mnr.
* Angaben der Muetter zuspielen. 
match files file=*
           /table='temp_M.sav'
           /by ef3 ef4 mnr.
execute.
sort cases by  ef1 ef3 ef4 ef5.

* Zwischenspeicherung .
save /outfile = 'temp_mig3.sav'. 

* ---------------------------------------------------------------- .
new file.
get file = 'temp_mig3.sav' /drop mig_k migV_k migM_k Konvproc migneu kennung. 
* display variables.
* fre MIG3 MIG_V  MIG_M.

* nur im Inland Geborene werden der Konversions-Prozedur unterworfen .
if not any (MIG3, 11, 21, 22, 23, 25, 29, 31, 41) KonvProc=1.
execute.

* Vorbereitung MATCH Konversionstabelle.
do if (KonvProc=1).
    recode MIG3   (else=copy) into mig_k.                           /* MIG-Status Person vor Konversion  */
    recode MIG_V  (sysmis=99) (22 23=21) (else=copy) into migV_k.   /* MIG-Status Vater */
    recode MIG_M  (sysmis=99) (22 23=21) (else=copy) into migM_k.   /* MIG-Status Mutter */
end if.
formats mig_k migV_k migM_k (f2.0).
execute.

* fre mig_k migV_k migM_k KonvProc.

sort cases by mig_k migV_k migM_k KonvProc.
match files file = *
            table = 'conversion.sav' 
     /by mig_k migV_k migM_k KonvProc.

* Ausgangssortierung.
sort cases by  ef1 ef3 ef4 ef5.

* neu, da durch Match ggf. ueberschrieben.
if not any (MIG3, 11, 21, 22, 23, 25, 29, 31, 41) KonvProc=1.
execute.

* Migrationsstatus NACH Konversion zuweisen.
if not(sysmis(migneu)) MIG4 = migneu.
if (sysmis(migneu))    MIG4 = MIG3.

var label MIG4 'Migrationsstatus nach Endtypisierung Befragte'.
formats MIG4 (f2.0).
* fre MIG4.

* SA_erw durch aussagekraeftigen Vater- oder Mutter eintrag ergaenzen, .
*        sofern noetig und moeglich .
do if (KonvProc=1).
   if ( (SA_erw=0 | SA_erw=99) & (SA_erw_V>0 & SA_erw_V<99) ) SA_erw=SA_erw_V.
   if ( (SA_erw=0 | SA_erw=99) & (SA_erw_M>0 & SA_erw_M<99) ) SA_erw=SA_erw_M.
end if.
execute.

* SUF Value Labels & Vergroeberung.
value label MIG4
       0 'Deutsch ohne Migrationshintergrund'
      11 'Bis einschliesslich 1949 als Deutscher ohne Einbuergerung auf das heutige Bundesgebiet zugewandert'
      21 '1950 und spaeter als Deutscher ohne Einbuergerung auf das heutige Bundesgebiet zugewandert(Spaetaussiedler)'
      22 'Ehegatte oder Kind von Spaetaussiedler, zeitgleich eingereist'
      25 'Spaetaussiedler mit formaler Einbuergerung'
      29 '(Spaet-)Aussiedler (mit/ohne Einbuergerung) o.A. zum Zuzugsjahr'
      31 'Als Auslaender auf das heutige Bundesgebiet zugewandert und zwischenzeitlich eingebuergert'
      32 'Als Auslaender im heutigen Bundesgebiet geboren und zwischenzeitlich eingebuergert'
      41 'Als Auslaender auf das heutige Bundesgebiet zuwandert'
      42 'Als Auslaender im heutigen Bundesgebiet geboren, entweder beide Eltern als Auslaender zugewandert oder der eine Elternteil'
      43 'Als Auslaender im heutigen Bundesgebiet geboren, beide Eltern im heutigen Bundesgebiet geboren'
      52 'Deutscher mit einseitigem Migrationshintergrund; Migrationsstatus durchweg identifizierbar, weil mit Eltern im Haushalt'
      53 'Deutscher mit einseitigem Migrationshintergrund; Migrationsstatus durchweg identifizierbar, weil mit Eltern im Haushalt'
      54 'Deutscher mit einseitigem Migrationshintergrund; Migrationsstatus durchweg identifizierbar, weil mit Eltern im Haushalt'
      62 'Deutscher mit beidseitigem Migrationshintergrund; Migrationsstatus durchweg identifizierbar, weil mit Eltern im Haushalt'
      63 'Deutscher mit beidseitigem Migrationshintergrund; Migrationsstatus durchweg identifizierbar, weil mit Eltern im Haushalt'
      64 'Deutscher mit beidseitigem Migrationshintergrund; Migrationsstatus durchweg identifizierbar, weil mit Eltern im Haushalt'
      77 'uneindeutig ob deutsch, vertrieben oder Spaetaussiedler'.
formats mig4 (f2.0).
execute.


* 6. Umsetzung von Zeitreihenkompatibilitaet entfaellt im MZ 2007 .


* ====================================================================.
* 7. Variablendefinitionen wie im SUF und fuer Fachserien-Ergebnisse  .

* Vergroeberungen wie SUF MZ 2008 .
recode MIG4 (29=21) (77 99=0) (else=copy) into mig.
var label mig 'Migrationsstatus'.
formats mig (f2.0).
value label mig 
    0 'Deutsch ohne Migrationshintergrund; '
      + 'uneindeutig ob deutsch, vertrieben oder Spaetaussiedler (0, 77, 99)!'
   11 'Bis einschliesslich 1949 als Deutscher ohne Einbuergerung auf das heutige Bundesgebiet zugewandert'
   21 '21/29: 1950 und spaeter als Deutscher ohne Einbuergerung auf das heutige Bundesgebiet zugewandert(Spaetaussiedler'
      +   'Ohne Angabe des Zuzugsjahrs als Deutscher ohne Einbuergerung auf das heutige Bundesgebiet zuwandert'
   22 'Ehegatte oder Kind von Spaetaussiedler, zeitgleich eingereist'
   25 'Spaetaussiedler mit formaler Einbuergerung'
   31 'Als Auslaender auf das heutige Bundesgebiet zugewandert und zwischenzeitlich eingebuergert'
   32 'Als Auslaender im heutigen Bundesgebiet geboren und zwischenzeitlich eingebuergert'
   41 'Als Auslaender auf das heutige Bundesgebiet zuwandert'
   42 'Als Auslaender im heutigen Bundesgebiet geboren, entweder beide Eltern als Auslaender zugewandert oder der eine Elternteil als Auslaender zugewandert, der andere als Auslaender im heutigen Bundesgebiet geboren'
   43 'Als Auslaender im heutigen Bundesgebiet geboren, beide Eltern im heutigen Bundesgebiet geboren'
   52 'Deutscher mit einseitigem Migrationshintergrund; Migrationsstatus durchweg identifizierbar, weil mit Eltern im Haushalt lebend; ein Elternteil ist Spaetaussiedler (21, 22, 25, 29)'
   53 'Deutscher mit einseitigem Migrationshintergrund; Migrationsstatus durchweg identifizierbar, weil mit Eltern im Haushalt lebend; ein Elternteil ist Deutscher durch Einbuergerung (31, 32)'
   54 'Deutscher mit einseitigem Migrationshintergrund; Migrationsstatus durchweg identifizierbar, weil mit Eltern im Haushalt lebend; ein Elternteil ist Auslaender (41, 42, 43)'
   62 'Deutscher mit beidseitigem Migrationshintergrund; Migrationsstatus durchweg identifizierbar, weil mit Eltern im Haushalt lebend; mindestens ein Elternteil ist Spaetaussiedler (21, 22, 25, 29)'
   63 'Deutscher mit beidseitigem Migrationshintergrund; Migrationsstatus durchweg identifizierbar, weil mit Eltern im Haushalt lebend; entweder beide Eltern eingebuergert, (31, 32) oder ein Elternteil eingebuergert (31, 32), der andere Auslaender (41, 42, 43)'
   64 'Deutscher mit beidseitigem Migrationshintergrund; Migrationsstatus durchweg identifizierbar, weil mit Eltern im Haushalt lebend; beide Eltern sind Auslaender (41, 42, 43), es handelt sich um ein ius soli-Kind (Optionsmodell)'.


* ===================== MIGS ======================= .
* Rekodierung sa_erw => migs  .
compute migs=sa_erw.
if (mig=0) migs=0.
var label migs 'Staatsangehoerigkeit: Migrationsstatus'.
formats migs (f2.0).
value label migs 
   0 'Entfaellt (Deutsche ohne weitere Staatsangehoerigkeit)'
   4 '4/8/27: Daenemark(4); Finnland(8); Schweden(27)'
   9 'Frankreich'
  10 'Griechenland'
  13 'Italien'
  21 '1/18/21: Belgien(1); Luxemburg(18); Niederlande(21)'
  22 'Oesterreich'
  23 'Polen'
  24 'Portugal'
  25 '3/25: Bulgarien(3); Rumaenien(25)'
  31 '7/15/17/19/31/37: Estland(7); Lettland(15); Litauen(17); Malta(19); Slowenien(31); Zypern(37)'
  32 'Spanien'
  33 '30/33: Slowakei(30); Tschechische Republik(33)'
  35 'Ungarn'
  36 '11/36: Irland(11); Vereinigtes Koenigreich(36)'
   2 'Bosnien und Herzegowina'
   5 'Ehemalige Sowjetunion'
   6 'Ehemaliges Jugoslawien'
  14 'Kroatien'
  26 'Russische Foederation'
  28 '12/16/20/28: Island(12); Liechtenstein(16); Norwegen(20); Schweiz(28)'
  34 'Tuerkei'
  38 'Sonstiges Osteuropa'
  39 'Sonstiges Europa'
  56 'Ukraine'
  58 '58/59: Serbien(58); Montenegro(59)'
  40 'Marokko'
  41 'Sonstiges Nordafrika'
  42 'Sonstiges Afrika (ohne Marokko)'
  43 'Vereinigte Staaten von Amerika (USA)'
  45 '44/45: Sonstiges Nordamerika [Kanada](44); Mittelamerika und Karibik(45)'
  46 'Suedamerika'
  47 'Irak'
  48 'Iran'
  49 'Sonstiger Naher und Mittlerer Osten (ohne Iran)'
  57 'Kasachstan'
  50 'Vietnam'
  51 'Afghanistan'
  52 'Sonstiges Sued- und Suedostasien'
  53 'China'
  54 'Sonstiges Ostasien'
  55 '55/98: Uebrige Welt(55); Staatenlos(98)'
  99 'Ohne Angabe'.

* ======= ENDE MIG-TYPISIERUNG ===== .


* Fallzahlen. 
temporary. 
weight off.
fre mig migs.

* Hochgerechnete Verteilungen von MIG und MIGS. 
temporary. 
* Bevoelkerung am Hauptwohnsitz. 
select if (EF30>=1 & EF30<=2). 
* Hochrechnung Jahresdurchschnitt. 
weight by EF952. 
fre mig migs.

* Vergleich mit Tabelle 2, Fachserie 1 Bevoelkerung und Erwerbstaetigkeit, .
* Reihe 2.2, Bevoelkerung mit Migrationshintergrund. 
* Z_* := Zeilennummer in Tab. 2 .
recode MIG (0 thru 77=1) (else=sysmis) into Z001.
recode MIG (0,11,77=1) (else=sysmis) into Z002.
recode MIG (21 thru 29 31 32 41 thru 43 52 thru 54 62 thru 64=1) (else=sysmis) into Z005.
recode MIG (21 thru 29 31 41=1) (else=sysmis) into Z034.
recode MIG (41=1) (else=sysmis) into Z062.
recode MIG (21 thru 29 31=1) (else=sysmis) into Z089.
recode MIG (21 thru 29=1) (else=sysmis) into Z090.
recode MIG (31=1) (else=sysmis) into Z097.
recode MIG (42 43 32 52 thru 54 62 thru 64=1) (else=sysmis) into Z119.
recode MIG (42 43=1) (else=sysmis) into Z126.
recode MIG (32 52 thru 54 62 thru 64=1) (else=sysmis) into Z133.
recode MIG (32=1) (else=sysmis) into Z134.
recode MIG (52 thru 54 62 thru 64=1) into Z140.
recode MIG (62 thru 64=1) (else=sysmis) into Z141.
recode MIG (52 thru 54=1) (else=sysmis) into Z142.
var lab Z001 'Insgesamt [0-77]'.
var lab Z002 'Person ohne Migrationshintergrund [0,11,77]'.
var lab Z005 'Person mit Mig-hintergrund i.e.S. [21-64]'.
var lab Z034 'Bevoelkerung mit eigener Migrationserfahrung [21-31,41]'.
var lab Z062 '+ Auslaender mit Mig-erfahrung [41]'.
var lab Z089 '+ Deutsche mit Mig-erfahrung [21-31]'.
var lab Z090 '  - (Spaet-)Aussiedler [21-29]'.
var lab Z097 '  - durch Einbuergerung [31]'.
var lab Z119 'Bevoelkerung ohne eigene Mig-erfahrung [32,42-64]'.
var lab Z126 '+ Auslaender ohne Mig-erfahrung[42-43]'.
var lab Z133 '+ Deutsche mit Mig-hintergrund ohne Mig-erfahrung [32,52-64]'.
var lab Z134 '  - durch Einbuergerung [32]'.
var lab Z140 '  - mit mind. 1 zugew. o. als Ausl. in D geb. Elternteil [52-64]'.
var lab Z141 '    # mit beidseitigem Mig-hintergrund [62-64]'.
var lab Z142 '    # mit einseitigem Mig-hintergrund [52-54]'.
execute.
formats Z001 to Z142 (f8.2).

temporary.
select if (ef30>=1 & ef30<=2).
weight by ef952.
descriptives variables = Z001 to Z142  /statistics sum.


temporary.
* Fuer Vergleiche mit Tab. 2: Bevoelkerung nach detailliertem Migrationsstatus, Altersgruppen und Geschlecht.
* Statistisches Bundesamt (2009): Fachserie 1, Reihe 2.2, Bevoelkerung mit 
* Migrationshintergrund, Ergebnisse des Mikrozensus 2007. Wiesbaden. 
* http://www.destatis.de/jetspeed/portal/cms/Sites/destatis/Internet/DE/Content/Publikationen/Fachveroeffentlichungen/Bevoelkerung/MigrationIntegration/Migrationshintergrund2010220077004,property=file.pdf .
* Hinweis zur Auswertung von MIGS im Vergleich zur Veroeffentlichung mit 
* Tab. 2, Fachserie 1, Reihe 2.2 
* Deutsche Zuwanderer ohne Einbuergerung sowie in Deutschland geborene 
* Deutsche mit ein-/beidseitigem Migrationshintergund MIGS => 0 (deutsch) .
compute MIGS_R = MIGS.
if any(MIG,0,11,21,22,23,25,29,61,62,63,64,71,72,73,74) MIGS_R=0.
* Bevoelkerung am Hauptwohnsitz.
select if (ef30>=1 & ef30<=2).
* Personen mit Migrationshintergrund im engeren Sinn.
select if (Z005=1).
* Hochrechnung: Jahresdurchschnitt.
weight by ef952.
recode MIGS_R (0 thru 99=1) (else=sysmis) into Z00.
recode MIGS_R (01 thru 39,56,58,59=1) (else=sysmis) into Z06.
recode MIGS_R (01,03,04,07,08,09,10,11,13,15,17,18,19,21,22,23,24,25,27,30,31,32,33,35,36,37=1) (else=sysmis) into Z07.
recode MIGS_R (10=1) (else=sysmis) into Z08.
recode MIGS_R (13=1) (else=sysmis) into Z09.
recode MIGS_R (23=1) (else=sysmis) into Z10.
recode MIGS_R (02,05,06,12,14,16,20,26,28,29,34,38,39,56,58,59=1) (else=sysmis) into Z12.
recode MIGS_R (2=1) (else=sysmis) into Z13.
recode MIGS_R (14=1) (else=sysmis) into Z14.
recode MIGS_R (26=1) (else=sysmis) into Z15.
recode MIGS_R (34=1) (else=sysmis) into Z17.
recode MIGS_R (56=1) (else=sysmis) into Z18.
recode MIGS_R (40 thru 42=1) (else=sysmis) into Z19.
recode MIGS_R (43 thru 46=1) (else=sysmis) into Z20.
recode MIGS_R (47 thru 55 57=1) (else=sysmis) into Z22.
recode MIGS_R (47 thru 49 57=1) (else=sysmis) into Z23.
recode MIGS_R (57=1) (else=sysmis) into  Z24.
recode MIGS_R (50 thru 52=1) (else=sysmis) into Z25.
recode MIGS_R (98,99,0=1) (else=sysmis) into Z26.
var lab Z00 'Insgesamt [0-99]'.
var lab Z06 'Europa [01-39,56,58,59]'.
var lab Z07 'o EU 27 [01,03,04,07-11,13,15,17-19,21-25,27,30-33,35-37]'.
var lab Z08 'o Griechenland [10]'.
var lab Z09 'o Italien [13]'.
var lab Z10 'o Polen [23]'.
var lab Z12 'o Sonstiges Europa [02,05,06,12,14,16,20,26,28,29,34,38,39,56,58,59]'.
var lab Z13 'o Bosnien und Herzegowina [2]'.
var lab Z14 'o Kroatien [14]'.
var lab Z15 'o Russische Foederation [26]'.
var lab Z17 'o Tuerkei [34]'. 
var lab Z18 'o Ukraine [56]'.
var lab Z19 'Afrika [40-42]'.
var lab Z20 'Amerika [43-46]'  .
var lab Z22 'Asien, Australien und Ozeanien [47-55,57]'.
var lab Z23 'o Naher und Mittlerer Osten [47-49,57]'.                                        
var lab Z24 'Kasachstan [57]'.
var lab Z25 'o Sued- und Suedostasien [50-52]'.                    
var lab Z26 'Ohne Angabe bzw. unzutreffend [98,99,0]'.
descriptives variables = Z00 to Z26  /statistics sum.
 
 
* Sortierung nach Ordnungsnummern (EF1, EF3, EF4 (=EF4R), EF5 (=EF5R)) .
* oder Satznummer in Ausgangsdaten (ID_ORG) fuer Zusammenfuehren der   .
* erstellten Variablen MIG, MIGS, MIGS_R zum Scientific Use File .
sort cases by ID_ORG. /* Alternativ: ... by EF1 EF3 EF4 EF5 EF12  */

 
* Zwischenspeicherung mit korrigierten IDs und ggf. Variablenauswahl.
save outfile = 'mig2007.sav'.
*      /keep = ef1 ef3 ef4 ef5 ef12 ef30 ef952 ID_Org mig migs MIGS_R .

* ################################################################################.
* PROGRAMMENDE .

